﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Globalization;
using System.Threading;

namespace Csharp_Advance_S11E05_part_62
{
    class Program
    {
        static void Main(string[] args)
        {
        menu:
            Console.Clear();
            PrintDateTime();
            Console.WriteLine("\n\t1. View Teacher List");
            Console.WriteLine("\t2. Search a Teacher");
            Console.WriteLine("\t3. Add a Teacher");
            Console.WriteLine("\t4. Delete a Teacher");
            Console.WriteLine("\t5. Edit a Teacher");

            Console.Write($"\n\tPlease Select Item Of Menu: ");
            int menu = Convert.ToInt32(Console.ReadLine());


            switch (menu)
            {
                // واکشی تمام اطلاعات جدول استاد
                case 1:
                    PrintTeacherList();
                    Console.Write("\n\nFor Come Back To Menu Enter Any Key...");
                    Console.ReadKey();
                    goto menu;


                case 2:
                    Console.Clear();
                    PrintDateTime();
                    using (Db_TestEntities dataBase = new Db_TestEntities())
                    {
                        Console.Write("\n\tEnter Teacher Phone: ");
                        string phone = Console.ReadLine();
                        Console.Clear();
                        PrintDateTime();
                        // ADO.Net ==> "Select * from Table_Teacher Where TeacherId="+id

                        // آگر عملیات جستجو با فیلدی غیر از کلید اصلی بود
                        var teacher = dataBase.Teble_Teacher.FirstOrDefault(t => t.TeacherPhonenumber == phone);

                        // اگر عملیات جستجو از روی فیلد کلید اصلی بود
                        //var teacher = dataBase.Teble_Teacher.Find(9);
                        if (teacher != null)
                        {
                            Console.WriteLine($"id: {teacher.TeacherId}    user: {teacher.TeacherPhonenumber}\tpass: {teacher.TeacherPassword}\tRd: {teacher.RegisterDate}\tA: {teacher.IsActive}");
                        }
                        else
                        {
                            Console.Clear();
                            PrintDateTime();
                            Console.WriteLine("\n\tNot Found...");
                        }
                    }
                    Console.Write("\n\nFor Come Back To Menu Enter Any Key...");
                    Console.ReadKey();
                    goto menu;

                case 3:
                    Console.Clear();
                    PrintDateTime();

                    // ADO.Net ==> Insert Into Table_Teacher Values(مقادیر هر فیلد)

                    using (Db_TestEntities dataBase = new Db_TestEntities())
                    {
                        Console.Write("\n\tEnter PhoneNumber: ");
                        string phone1 = Console.ReadLine();
                        Console.Write("\n\tEnter password   : ");
                        string pass1 = Console.ReadLine();

                        dataBase.Teble_Teacher.Add(new Teble_Teacher()
                        {
                            TeacherPhonenumber = phone1,
                            TeacherPassword = pass1,
                            RegisterDate = DateTime.Now,
                            IsActive = true
                        });
                        dataBase.SaveChanges();
                        Console.Clear();
                        PrintDateTime();
                        Console.WriteLine("\n\tdarj anjam shod ...");

                        Thread.Sleep(2000);
                        goto menu;
                    }

                case 4:
                    // ADO.Net ==> "Delete fron Table_Teacher Where TeacherId="+id

                    PrintTeacherList();
                    Console.Write("\n\tEnter Teacher Id for Delete : ");
                    int id = Convert.ToInt32(Console.ReadLine());
                    Console.Clear();
                    using (Db_TestEntities dataBase = new Db_TestEntities())
                    {
                        var teacher = dataBase.Teble_Teacher.Find(id);

                        if (teacher != null)
                        {
                            dataBase.Teble_Teacher.Remove(teacher);
                            Console.WriteLine($"\n\tteacherid {id} hazf shod");
                            dataBase.SaveChanges();
                        }
                        else
                        {
                            Console.Clear();
                            PrintDateTime();
                            Console.WriteLine("\n\tNot Found ...");
                        }
                        Thread.Sleep(2000);
                        goto menu;
                    }

                case 5:
                    // ADO.Net ==> Update Table_Teacher Set PhoneNumber='556546' Where TeacherId=5

                    PrintTeacherList();
                    Console.Write("\n\tEnter Teacher Id for Edit : ");
                    int id1 = Convert.ToInt32(Console.ReadLine());
                    Console.Clear();
                    using (Db_TestEntities dataBase = new Db_TestEntities())
                    {
                        PrintDateTime();
                        var teacher1 = dataBase.Teble_Teacher.Find(id1);
                        Console.WriteLine($"\n\tTeacherId   : {teacher1.TeacherId}" +
                                          $"\n\tPhoneNumber : {teacher1.TeacherPhonenumber}" +
                                          $"\n\tPassword    : {teacher1.TeacherPassword}" +
                                          $"\n\tRegisterDate: {teacher1.RegisterDate}" +
                                          $"\n\tIsActive    : {teacher1.IsActive}");

                        Console.Write("\n\nEnter New PhoneNumber : ");
                        string phonenumber = Console.ReadLine();
                        Console.Write("Enter New Password    : ");
                        string password = Console.ReadLine();
                        teacher1.TeacherPhonenumber = phonenumber;
                        teacher1.TeacherPassword = password;
                        if (teacher1.IsActive)
                        {
                            teacher1.IsActive = false;
                        }
                        dataBase.SaveChanges();
                        Console.Clear();
                        PrintDateTime();
                        Console.WriteLine("\n\tvirayesh anjam shod ...");
                        Thread.Sleep(2000);
                        goto menu;
                    }
            }
            Console.ReadKey();
        }

        public static void PrintDateTime()
        {
            PersianCalendar pc = new PersianCalendar();
            Console.WriteLine($"{pc.GetYear(DateTime.Now)}/{pc.GetMonth(DateTime.Now)}/{pc.GetDayOfMonth(DateTime.Now)} {pc.GetHour(DateTime.Now)}:{pc.GetMinute(DateTime.Now)}");
            Console.WriteLine("--------------------------------------------------------------------------");
        }

        public static void PrintTeacherList()
        {
            Console.Clear();
            PrintDateTime();
            using (Db_TestEntities dataBase = new Db_TestEntities())
            {
                // ADO.Net ==> Select * from Table_Teacher
                List<Teble_Teacher> teacherList = dataBase.Teble_Teacher.ToList();
                foreach (Teble_Teacher teacher in teacherList)
                {
                    Console.WriteLine($"id: {teacher.TeacherId}    user: {teacher.TeacherPhonenumber}\tpass: {teacher.TeacherPassword}\tRd: {teacher.RegisterDate}\tA: {teacher.IsActive}");
                }
            }
        }
    }
}